Analytics Zoo provides plenty of examples and notebooks ready for re-use as listed below.

* [Image Classification](https://github.com/intel-analytics/analytics-zoo/tree/master/pyzoo/zoo/examples/imageclassification): This example illustrates how to classify images with a pre-trained model.
* [Object Detection](https://github.com/intel-analytics/analytics-zoo/tree/master/pyzoo/zoo/examples/objectdetection): This example illustrates how to detect objects in images with a pre-trained model.
* Recommendation: There are two Python notebooks for recommendation models, including [Wide and Deep](https://github.com/intel-analytics/analytics-zoo/tree/master/apps/recommendation-wide-n-deep) and [Neural Collaborative Filtering](https://github.com/intel-analytics/analytics-zoo/tree/master/apps/recommendation-ncf).
* [Text Classification](https://github.com/intel-analytics/analytics-zoo/tree/master/pyzoo/zoo/examples/textclassification): This example uses pre-trained GloVe embeddings to convert words to vectors and trains a CNN, LSTM or GRU TextClassifier model on 20 Newsgroup dataset.
* [DataFrame](https://github.com/intel-analytics/analytics-zoo/tree/master/pyzoo/zoo/examples/nnframes): There are three examples to show how to perform transfer learning and model inference using pre-trained Inception v1 model with DataFrame-based API.
* [TFNet](https://github.com/intel-analytics/analytics-zoo/tree/master/pyzoo/zoo/examples/tensorflow/tfnet): This example illustrates how to use a pre-trained TensorFlow object detection model to make inferences.
* [QARanker](https://github.com/intel-analytics/analytics-zoo/tree/master/pyzoo/zoo/examples/qaranker): This example trains and evaluates a KNRM model on WikiQA dataset for ranking.
* [Distributed TensorFlow](https://github.com/intel-analytics/analytics-zoo/tree/master/pyzoo/zoo/examples/tensorflow/distributed_training): There are several examples to demonstrate how to run distributed TensorFlow and Keras on Spark/BigDL.
* [Anomaly Detection](https://github.com/intel-analytics/analytics-zoo/tree/master/pyzoo/zoo/examples/anomalydetection): This example illustrates how to use LSTM to detect anomalies on NYC taxi passengers dataset.
* See [here](../ProgrammingGuide/usercases-overview.md) for more notebooks on user applications and demos.
